package com.dhcc.finance.main.model;

import java.math.BigDecimal;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 功能描述：固有代垫流水信息
 * @author likai
 * @date 2020年4月14日 下午2:20:29
 * @修改日志：
 */
@ApiModel(value = "FundProjectInfoGydd",description = "固有代垫项目信息")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class FundProjectInfoGydd {
	/**
     * 信托子项目编号
     */
    @ApiModelProperty(value = "信托子项目编号", required = false, example = "")
    private String xtzxmbh;
    
    /**
     * 账套编号
     */
    @ApiModelProperty(value = "账套编号", required = false, example = "")
    private String code;
    
    /**
     * 账套主键
     */
    @ApiModelProperty(value = "账套主键", required = false, example = "")
    private String pkGlorgbook;
    /**
     * 当前期间
     */
    @ApiModelProperty(value = "当前期间", required = false, example = "")
    private String pkCurrperiod;
    
    /**
     * 科目编码
     */
    @ApiModelProperty(value = "科目编码", required = false, example = "")
    private String subjcode;
    
    /**
     * 核算会计
     */
    @ApiModelProperty(value = "核算会计", required = false, example = "")
    private String userId;
    /**
     * 代垫款金额
     */
    @ApiModelProperty(value = "代垫款金额", required = false, example = "")
    private BigDecimal balance;
    
    @ApiModelProperty(value = "固定报酬", required = false, example = "")
    private BigDecimal fdbc;
    
    @ApiModelProperty(value = "浮动报酬", required = false, example = "")
    private BigDecimal gdbc;
    
 

}
