package com.dhcc.finance.main.service;

import java.util.List;

import com.dhcc.common.model.CurrencyMeta;
import com.dhcc.common.model.response.RestfulResponse;
import com.dhcc.finance.main.domain.CwBdAccass;
import com.github.pagehelper.PageInfo;

/**
 * 功能描述：科目辅助配置接口
 * @author dml
 * @date 2019年3月22日 下午1:50:12
 * @修改日志：
 */
public interface CwBdAccassService {
	/**
	 * 功能描述：新增科目辅助配置
	 * @param cwBdAccass
	 * @return RestfulResponse<Object,CurrencyMeta>
	 * @author dml
	 * @date 2019年3月22日 下午1:55:00
	 * @修改日志：
	 */
	RestfulResponse<Object, CurrencyMeta> addCwBdAccass(CwBdAccass cwBdAccass);
	
	/**
	 * 功能描述：修改科目辅助配置
	 * @param cwBdAccass
	 * @return RestfulResponse<Object,CurrencyMeta>
	 * @author dml
	 * @date 2019年3月22日 下午1:55:04
	 * @修改日志：
	 */
	RestfulResponse<Object, CurrencyMeta> updateCwBdAccassByPk(CwBdAccass cwBdAccass);
	
	/**
	 * 功能描述：逻辑删除科目辅助配置
	 * @param pkAccass
	 * @return RestfulResponse<Object,CurrencyMeta>
	 * @author dml
	 * @date 2019年3月22日 下午1:55:15
	 * @修改日志：
	 */
	RestfulResponse<Object, CurrencyMeta> deleteCwBdAccassByPk(String pkAccass);
	
	/**
	 * 功能描述：根据科目查询科目辅助配置
	 * @param pkAccsubj
	 * @param pageNum
	 * @param pageSize
	 * @param navigatePages
	 * @return RestfulResponse<PageInfo<CwBdAccass>,CurrencyMeta>
	 * @author dml
	 * @date 2019年3月22日 下午1:55:25
	 * @修改日志：
	 */
	RestfulResponse<PageInfo<CwBdAccass>, CurrencyMeta> searchCwBdAccassInfo(String pkAccsubj, int pageNum, int pageSize, int navigatePages);
	
	/* 功能描述   根据科目主键科目版本主键查询科目下辅助配置信息
	 * @param pkAccsubj
	 * @param pkSubjscheme
	 * @return RestfulResponse<List<CwBdAccass>,CurrencyMeta>
	 * @author huangpeng
	 * @date 2019年6月17日 上午10:25:40
	 * 修改日志
	 */
	RestfulResponse<List<CwBdAccass>, CurrencyMeta> searchCwBdAccassforAddVoucher(String pkAccsubj,String pkSubjscheme);
}
