package com.dhcc.finance.main.service;

import com.dhcc.common.model.CurrencyMeta;
import com.dhcc.common.model.response.RestfulResponse;
import com.dhcc.finance.main.model.FileUploadRequest;
import com.dhcc.finance.main.model.FileUploadRequestTemp;

/**
 * 功能描述：科目辅助余额表接口
 * @author dml
 * @date 2019年4月22日 上午10:56:12
 * @修改日志：
 */
public interface CwGlBalanceService {
	/**
	 * 功能描述：年初重算
	 * @param pkGlorgbook 账套主键
	 * @param year 年份
	 * @return RestfulResponse<Object,CurrencyMeta>
	 * @author dml
	 * @date 2019年4月22日 上午11:07:26
	 * @修改日志：
	 */
	RestfulResponse<Object, CurrencyMeta> earlyYearRecalculation(String pkGlorgbook,String year);
	/**
	 * 功能描述：导入期初余额
	 * @param fileUploadRequest
	 * @param type
	 * @return RestfulResponse<Object,CurrencyMeta>
	 * @author dml
	 * @date 2019年4月24日 下午3:54:47
	 * @修改日志：
	 */
	RestfulResponse<String, CurrencyMeta> uploadCwGlBalance(FileUploadRequest fileUploadRequest, String  type);
	/**
	 * @param pkGlorgbook
	 * @param period
	 * @param pkAccsub
	 * @return RestfulResponse<Object,CurrencyMeta>
	 *@author huangpeng
	 *@date 2019年4月28日 下午5:59:59
	 *@修改日志：
	 */
	RestfulResponse<String, CurrencyMeta> seachCwGlBalanceSum(String pkGlorgbook, String period, String pkAccsubj,String balanorient);
	 /**
     * 功能描述:导入期初临时表
     * @param fileUploadRequestTemp
     * @param pkGlorgbook
     * @param period
     * @return RestfulResponse<String,CurrencyMeta>
     *@author baiyc
     *@date 2019年5月5日 上午11:41:05
     *@修改日志:
     */
    RestfulResponse<String, CurrencyMeta> uploadCwGlInitbuildTemp(FileUploadRequestTemp fileUploadRequestTemp,
               String pkGlorgbook, String period);
}
